# Copyright (c) 2015 3D Control Systems LTD

# Author: Vladimir Avdeev <another.vic@yandex.ru>, Oleg Panasevych <panasevychol@gmail.com>

import logging
import time

class CheckerWaiter:

    CHECK_PERIOD = 0.1
    NAME_FOR_LOGGING = 'place your name for logging here'

    def __init__(self, app, check_function):
        self.check_function = check_function
        self.logger = logging.getLogger(self.__class__.__name__)
        self.logger.setLevel('INFO')
        self.app = app
        self.ignore_flag = False
        self.waiting = not self.check_function()

    def wait(self):
        if self.waiting:
            self.logger.info('Waiting for an action: ' + self.NAME_FOR_LOGGING)
            while not self.check_function() and not self.ignore_flag and not self.app.stop_flag:
                time.sleep(self.CHECK_PERIOD)
            self.waiting = False
            self.logger.info('...end of waiting for: ' + self.NAME_FOR_LOGGING)
        return not self.app.stop_flag